#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1600five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 1600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five16004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five16004xi = {
                1: '-1009x637y1064z',
                2: '-1016x738y990z',
                3: '-103x494y1518z',
                4: '-1050x1135y410z',
                5: '-1050x589y1052z',
                6: '-1062x689y977z',
                7: '-1089x538y1040z',
                8: '-1105x638y964z',
                9: '-1111x1081y394z',
                10: '-1125x484y1028z',
                11: '-113x1077y1177z',
                12: '-1145x583y951z',
                13: '-1159x428y1016z',
                14: '-115x0y1595z',
                15: '-1169x1024y379z',
                16: '-1183x526y939z',
                17: '-1189x370y1003z',
                18: '-1216x310y991z',
                19: '-1218x467y926z',
                20: '-1224x964y363z',
                21: '-1241x247y978z',
                22: '-1249x406y912z',
                23: '-1262x183y966z',
                24: '-1275x900y348z',
                25: '-1277x342y899z',
                26: '-1279x118y953z',
                27: '-1302x276y886z',
                28: '-1324x209y873z',
                29: '-1324x834y332z',
                30: '-133x503y1512z',
                31: '-1342x141y859z',
                32: '-1356x71y846z',
                33: '-1366x0y832z',
                34: '-1368x765y316z',
                35: '-1374x54y999z',
                36: '-1409x694y301z',
                37: '-1446x620y285z',
                38: '-1479x545y269z',
                39: '-1508x467y253z',
                40: '-1533x388y238z',
                41: '-1554x308y222z',
                42: '-1570x226y206z',
                43: '-1582x144y190z',
                44: '-1589x61y174z',
                45: '-163x510y1507z',
                46: '-170x994y1241z',
                47: '-171x1081y1166z',
                48: '-175x1475y592z',
                49: '-195x514y1502z',
                50: '-19x6y1599z',
                51: '-224x996y1231z',
                52: '-228x517y1496z',
                53: '-230x1082y1155z',
                54: '-253x1470y577z',
                55: '-262x518y1490z',
                56: '-279x995y1221z',
                57: '-289x1079y1144z',
                58: '-296x516y1484z',
                59: '-330x513y1478z',
                60: '-331x1460y562z',
                61: '-335x990y1210z',
                62: '-348x1074y1133z',
                63: '-34x9y1599z',
                64: '-365x507y1472z',
                65: '-391x983y1200z',
                66: '-3x1y1599z',
                67: '-401x498y1466z',
                68: '-408x1064y1122z',
                69: '-408x1446y547z',
                70: '-436x487y1459z',
                71: '-447x972y1189z',
                72: '-468x1052y1110z',
                73: '-471x474y1453z',
                74: '-485x1428y532z',
                75: '-48x472y1527z',
                76: '-503x957y1178z',
                77: '-506x459y1446z',
                78: '-50x11y1599z',
                79: '-527x1036y1099z',
                80: '-541x441y1439z',
                81: '-558x940y1167z',
                82: '-561x1405y517z',
                83: '-575x420y1432z',
                84: '-586x1016y1087z',
                85: '-608x397y1425z',
                86: '-613x919y1156z',
                87: '-636x1379y502z',
                88: '-640x372y1418z',
                89: '-645x993y1075z',
                90: '-667x895y1145z',
                91: '-671x344y1410z',
                92: '-67x10y1598z',
                93: '-701x315y1402z',
                94: '-702x966y1063z',
                95: '-710x1348y487z',
                96: '-720x867y1134z',
                97: '-730x282y1395z',
                98: '-757x248y1387z',
                99: '-758x937y1051z',
                100: '-75x484y1523z',
                101: '-772x837y1123z',
                102: '-782x1313y471z',
                103: '-782x212y1379z',
                104: '-806x174y1371z',
                105: '-813x903y1039z',
                106: '-823x803y1111z',
                107: '-827x133y1362z',
                108: '-83x9y1597z',
                109: '-846x91y1354z',
                110: '-852x1274y456z',
                111: '-864x48y1345z',
                112: '-867x867y1027z',
                113: '-872x766y1100z',
                114: '-878x2y1337z',
                115: '-919x827y1014z',
                116: '-920x1231y441z',
                117: '-920x726y1088z',
                118: '-965x683y1076z',
                119: '-969x784y1002z',
                120: '-986x1185y425z',
                121: '-99x5y1596z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1600five4xi" usage = "target function for charge16004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire1600five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1600FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1600FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1600FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1600FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1600FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five16004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1600FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1600FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1600FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five16004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five16004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1600FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1600FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1600FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1600five4xi.py                             
# -------------------------------------------------------------------------------------------------                